From 2a5c7900192660ff21ea4ba63bfd706af60b113a Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Sun, 29 Nov 2015 23:53:34 +0100
Subject: [PATCH 04/55] kernel/drm: nouveau changes so far. :)

---
 sys/conf/files                                |  22 +-
 sys/conf/kern.pre.mk                          |   2 +-
 sys/config/LINT64                             |   1 +
 sys/dev/drm/include/acpi/button.h             |  57 +++
 sys/dev/drm/include/asm/io.h                  |   7 +
 sys/dev/drm/include/drm/drmP.h                |   1 +
 sys/dev/drm/include/drm/i2c/ch7006.h          |  86 +++++
 sys/dev/drm/include/drm/i2c/sil164.h          |  63 ++++
 sys/dev/drm/include/linux/bitops.h            |   7 +
 sys/dev/drm/include/linux/compiler.h          |   2 +
 sys/dev/drm/include/linux/dma-attrs.h         |  50 +++
 sys/dev/drm/include/linux/dma-buf.h           |  35 ++
 sys/dev/drm/include/linux/fb.h                |   9 +
 sys/dev/drm/include/linux/fence.h             |   2 +
 sys/dev/drm/include/linux/gfp.h               |   1 +
 sys/dev/drm/include/linux/hwmon-sysfs.h       |  35 ++
 sys/dev/drm/include/linux/hwmon.h             |  35 ++
 sys/dev/drm/include/linux/i2c.h               |  13 +
 sys/dev/drm/include/linux/init.h              |  35 ++
 sys/dev/drm/include/linux/kernel.h            |   1 +
 sys/dev/drm/include/linux/list.h              |   9 +-
 sys/dev/drm/include/linux/lockdep.h           |   2 +
 sys/dev/drm/include/linux/mod_devicetable.h   |   2 +
 sys/dev/drm/include/linux/mutex.h             |   3 +
 sys/dev/drm/include/linux/page.h              |  53 +++
 sys/dev/drm/include/linux/platform_device.h   |  35 ++
 sys/dev/drm/include/linux/pm_runtime.h        |  86 +++++
 sys/dev/drm/include/linux/power_supply.h      |  41 ++
 sys/dev/drm/include/linux/printk.h            |   1 +
 sys/dev/drm/include/linux/rbtree.h            |   5 +
 sys/dev/drm/include/linux/rcupdate.h          |  35 ++
 sys/dev/drm/include/linux/reboot.h            |  49 +++
 sys/dev/drm/include/linux/rwlock.h            |  47 +++
 sys/dev/drm/include/linux/screen_info.h       |  35 ++
 sys/dev/drm/include/linux/slab.h              |   3 +
 sys/dev/drm/include/linux/spinlock.h          |   4 +
 sys/dev/drm/include/linux/stat.h              |  37 ++
 sys/dev/drm/include/linux/static_key.h        |   1 +
 sys/dev/drm/include/linux/string.h            |  20 +
 sys/dev/drm/include/linux/swiotlb.h           |  35 ++
 sys/dev/drm/include/linux/sysrq.h             |  49 +++
 sys/dev/drm/include/linux/tracepoint.h        |  35 ++
 sys/dev/drm/include/linux/tty.h               |  35 ++
 sys/dev/drm/include/linux/vgaarb.h            |  49 +++
 sys/dev/drm/include/linux/workqueue.h         |   7 +
 sys/dev/drm/include/trace/define_trace.h      | 118 ++++++
 sys/dev/drm/include/trace/events/fence.h      |  35 ++
 sys/dev/drm/include/uapi_drm/nouveau_drm.h    | 150 ++++++++
 sys/dev/drm/nouveau/NOTES                     |   9 +
 .../nouveau/core/core/nouveau_core_client.c   |   4 +-
 .../nouveau/core/core/nouveau_core_engctx.c   |   2 +-
 .../nouveau/core/core/nouveau_core_ioctl.c    |   6 +-
 .../drm/nouveau/core/core/nouveau_core_mm.c   |   4 +-
 .../nouveau/core/core/nouveau_core_notify.c   |   6 +-
 .../nouveau/core/core/nouveau_core_printk.c   |   8 +-
 .../engine/copy/nouveau_engine_copy_nva3.c    |   2 +-
 .../engine/crypt/nouveau_engine_crypt_nv84.c  |   2 +-
 .../engine/crypt/nouveau_engine_crypt_nv98.c  |   2 +-
 .../device/nouveau_engine_device_base.c       |  12 +-
 .../device/nouveau_engine_device_ctrl.c       |   4 +-
 .../engine/disp/nouveau_engine_disp_nv50.c    |  14 +-
 .../dmaobj/nouveau_engine_dmaobj_base.c       |   2 +-
 .../engine/fifo/nouveau_engine_fifo_base.c    |   2 +-
 .../engine/fifo/nouveau_engine_fifo_nv04.c    |   4 +-
 .../engine/fifo/nouveau_engine_fifo_nv10.c    |   2 +-
 .../engine/fifo/nouveau_engine_fifo_nv17.c    |   2 +-
 .../engine/fifo/nouveau_engine_fifo_nv40.c    |   2 +-
 .../engine/fifo/nouveau_engine_fifo_nv50.c    |   4 +-
 .../engine/fifo/nouveau_engine_fifo_nv84.c    |   4 +-
 .../engine/fifo/nouveau_engine_fifo_nvc0.c    |  16 +-
 .../engine/fifo/nouveau_engine_fifo_nve0.c    |  18 +-
 .../graph/nouveau_engine_graph_ctxgm107.c     |   2 +-
 .../graph/nouveau_engine_graph_ctxnv40.c      |   2 +-
 .../graph/nouveau_engine_graph_ctxnv50.c      |   2 +-
 .../graph/nouveau_engine_graph_ctxnvc0.c      |   2 +-
 .../graph/nouveau_engine_graph_ctxnvd7.c      |   2 +-
 .../engine/graph/nouveau_engine_graph_gm107.c |   2 +-
 .../engine/graph/nouveau_engine_graph_nv04.c  |   2 +-
 .../engine/graph/nouveau_engine_graph_nv10.c  |   2 +-
 .../engine/graph/nouveau_engine_graph_nv50.c  |   8 +-
 .../engine/graph/nouveau_engine_graph_nvc0.c  |  18 +-
 .../core/engine/nouveau_engine_falcon.c       |  18 +-
 .../core/engine/nouveau_engine_xtensa.c       |  10 +-
 .../perfmon/nouveau_engine_perfmon_base.c     |  10 +-
 .../drm/nouveau/core/include/core/device.h    |   4 +-
 .../drm/nouveau/core/include/core/engine.h    |   2 +-
 sys/dev/drm/nouveau/core/include/core/event.h |   4 +-
 .../drm/nouveau/core/include/core/namedb.h    |   2 +-
 .../drm/nouveau/core/include/core/object.h    |  12 +-
 .../drm/nouveau/core/include/core/subdev.h    |   2 +-
 .../drm/nouveau/core/include/engine/fifo.h    |   2 +-
 sys/dev/drm/nouveau/core/include/subdev/i2c.h |  16 +-
 sys/dev/drm/nouveau/core/os.h                 |   9 +-
 .../core/subdev/bar/nouveau_subdev_bar_base.c |   2 +-
 .../subdev/bar/nouveau_subdev_bar_gk20a.c     |   2 +-
 .../core/subdev/bar/nouveau_subdev_bar_nv50.c |   2 +-
 .../core/subdev/bar/nouveau_subdev_bar_nvc0.c |   2 +-
 .../subdev/bios/nouveau_subdev_bios_base.c    |  20 +-
 .../subdev/bios/nouveau_subdev_bios_init.c    |  12 +-
 .../core/subdev/bus/nouveau_subdev_bus_hwsq.c |   2 +-
 .../subdev/clock/nouveau_subdev_clock_base.c  |  10 +-
 .../subdev/clock/nouveau_subdev_clock_nv50.c  |   2 +-
 .../core/subdev/fb/nouveau_subdev_fb_nv50.c   |   4 +-
 .../subdev/fb/nouveau_subdev_fb_ramgk20a.c    |   2 +-
 .../subdev/fb/nouveau_subdev_fb_ramnv1a.c     |  10 +-
 .../subdev/gpio/nouveau_subdev_gpio_nve0.c    |   2 +-
 .../subdev/i2c/nouveau_subdev_i2c_anx9805.c   |   8 +-
 .../core/subdev/i2c/nouveau_subdev_i2c_aux.c  |   2 +-
 .../core/subdev/i2c/nouveau_subdev_i2c_base.c |   2 +-
 .../core/subdev/i2c/nouveau_subdev_i2c_nv94.c |   2 +-
 .../instmem/nouveau_subdev_instmem_nv50.c     |   2 +-
 .../core/subdev/mc/nouveau_subdev_mc_base.c   |   4 +-
 .../core/subdev/mxm/nouveau_subdev_mxm_base.c |   8 +-
 .../core/subdev/mxm/nouveau_subdev_mxm_nv50.c |   2 +-
 .../therm/nouveau_subdev_therm_fantog.c       |   2 +-
 .../subdev/therm/nouveau_subdev_therm_temp.c  |   2 +-
 sys/dev/drm/nouveau/core/subdev/therm/priv.h  |   6 +-
 .../subdev/timer/nouveau_subdev_timer_nv04.c  |   2 +-
 sys/dev/drm/nouveau/core/subdev/timer/nv04.h  |   2 +-
 .../core/subdev/vm/nouveau_subdev_vm_nv41.c   |   2 +-
 .../core/subdev/vm/nouveau_subdev_vm_nv44.c   |   2 +-
 .../dispnv04/nouveau_dispnv04_cursor.c        |   4 +
 .../nouveau/dispnv04/nouveau_dispnv04_hw.c    |   2 +-
 .../dispnv04/nouveau_dispnv04_overlay.c       |   4 +
 sys/dev/drm/nouveau/nouveau_abi16.c           |   6 +-
 sys/dev/drm/nouveau/nouveau_acpi.c            |   2 +-
 sys/dev/drm/nouveau/nouveau_agp.c             |   2 +-
 sys/dev/drm/nouveau/nouveau_bios.h            |   2 +-
 sys/dev/drm/nouveau/nouveau_bo.c              |   9 +-
 sys/dev/drm/nouveau/nouveau_bo.h              |   2 +
 sys/dev/drm/nouveau/nouveau_display.c         |  22 +-
 sys/dev/drm/nouveau/nouveau_drm.c             |  27 +-
 sys/dev/drm/nouveau/nouveau_drm.h             |  10 +-
 sys/dev/drm/nouveau/nouveau_fbcon.c           |   2 +-
 sys/dev/drm/nouveau/nouveau_fence.c           |   4 +-
 sys/dev/drm/nouveau/nouveau_fence.h           |   2 +-
 sys/dev/drm/nouveau/nouveau_gem.c             |  18 +-
 sys/dev/drm/nouveau/nouveau_hwmon.c           |  36 +-
 sys/dev/drm/nouveau/nouveau_nv10_fence.c      |   2 +-
 sys/dev/drm/nouveau/nouveau_nv50_display.c    |  16 +-
 sys/dev/drm/nouveau/nouveau_nvif.c            |   2 +-
 sys/dev/drm/nouveau/nouveau_platform.c        |   3 +-
 sys/dev/drm/nouveau/nouveau_prime.c           |   2 +
 sys/dev/drm/nouveau/nouveau_sgdma.c           |   1 +
 sys/dev/drm/nouveau/nouveau_sysfs.c           |   2 +-
 sys/dev/drm/nouveau/nouveau_ttm.c             |   4 +-
 sys/dev/drm/nouveau/nouveau_usif.c            |  12 +-
 sys/dev/drm/nouveau/nv10_fence.h              |   2 +-
 sys/dev/drm/nouveau/nvif/list.h               | 353 ------------------
 .../drm/nouveau/nvif/nouveau_nvif_notify.c    |   8 +-
 .../drm/nouveau/nvif/nouveau_nvif_object.c    |   6 +-
 sys/libkern/strcspn.c                         |  72 ++++
 sys/sys/libkern.h                             |  13 +
 153 files changed, 1844 insertions(+), 637 deletions(-)
 create mode 100644 sys/dev/drm/include/acpi/button.h
 create mode 100644 sys/dev/drm/include/drm/i2c/ch7006.h
 create mode 100644 sys/dev/drm/include/drm/i2c/sil164.h
 create mode 100644 sys/dev/drm/include/linux/dma-attrs.h
 create mode 100644 sys/dev/drm/include/linux/dma-buf.h
 create mode 100644 sys/dev/drm/include/linux/hwmon-sysfs.h
 create mode 100644 sys/dev/drm/include/linux/hwmon.h
 create mode 100644 sys/dev/drm/include/linux/init.h
 create mode 100644 sys/dev/drm/include/linux/page.h
 create mode 100644 sys/dev/drm/include/linux/platform_device.h
 create mode 100644 sys/dev/drm/include/linux/pm_runtime.h
 create mode 100644 sys/dev/drm/include/linux/power_supply.h
 create mode 100644 sys/dev/drm/include/linux/rcupdate.h
 create mode 100644 sys/dev/drm/include/linux/reboot.h
 create mode 100644 sys/dev/drm/include/linux/rwlock.h
 create mode 100644 sys/dev/drm/include/linux/screen_info.h
 create mode 100644 sys/dev/drm/include/linux/stat.h
 create mode 100644 sys/dev/drm/include/linux/static_key.h
 create mode 100644 sys/dev/drm/include/linux/swiotlb.h
 create mode 100644 sys/dev/drm/include/linux/sysrq.h
 create mode 100644 sys/dev/drm/include/linux/tracepoint.h
 create mode 100644 sys/dev/drm/include/linux/tty.h
 create mode 100644 sys/dev/drm/include/linux/vgaarb.h
 create mode 100644 sys/dev/drm/include/trace/define_trace.h
 create mode 100644 sys/dev/drm/include/trace/events/fence.h
 create mode 100644 sys/dev/drm/include/uapi_drm/nouveau_drm.h
 create mode 100644 sys/dev/drm/nouveau/NOTES
 delete mode 100644 sys/dev/drm/nouveau/nvif/list.h
 create mode 100644 sys/libkern/strcspn.c

diff --git a/sys/conf/files b/sys/conf/files
index aef805a80d..b34307a0c7 100644
--- a/sys/conf/files
+++ b/sys/conf/files
@@ -1998,6 +1998,7 @@ libkern/strtol.c			standard
 libkern/strtoq.c			standard
 libkern/strtoul.c			standard
 libkern/strtouq.c			standard
+libkern/strcspn.c			standard
 #libkern/stack_protector.c		standard
 libiconv/iconv.c			optional libiconv
 libiconv/iconv_converter_if.m		optional libiconv
@@ -2361,7 +2362,7 @@ dev/drm/nouveau/core/subdev/bus/nouveau_subdev_bus_nv50.c		optional nouveau drm
 dev/drm/nouveau/core/subdev/bus/nouveau_subdev_bus_nv94.c		optional nouveau drm
 dev/drm/nouveau/core/subdev/bus/nouveau_subdev_bus_nvc0.c		optional nouveau drm
 dev/drm/nouveau/core/subdev/clock/nouveau_subdev_clock_base.c		optional nouveau drm
-dev/drm/nouveau/core/subdev/clock/nouveau_subdev_clock_gk20a.c		optional nouveau drm
+#dev/drm/nouveau/core/subdev/clock/nouveau_subdev_clock_gk20a.c		optional nouveau drm
 dev/drm/nouveau/core/subdev/clock/nouveau_subdev_clock_nv04.c		optional nouveau drm
 dev/drm/nouveau/core/subdev/clock/nouveau_subdev_clock_nv40.c		optional nouveau drm
 dev/drm/nouveau/core/subdev/clock/nouveau_subdev_clock_nv50.c		optional nouveau drm
@@ -2516,36 +2517,41 @@ dev/drm/nouveau/dispnv04/nouveau_dispnv04_tvmodesnv17.c		optional nouveau drm
 dev/drm/nouveau/dispnv04/nouveau_dispnv04_tvnv04.c		optional nouveau drm
 dev/drm/nouveau/dispnv04/nouveau_dispnv04_tvnv17.c		optional nouveau drm
 dev/drm/nouveau/nouveau_abi16.c		optional nouveau drm
+#dev/drm/nouveau/nouveau_acpi.c		optional nouveau drm
 dev/drm/nouveau/nouveau_agp.c		optional nouveau drm
+#dev/drm/nouveau/nouveau_backlight.c	optional nouveau drm
 dev/drm/nouveau/nouveau_bios.c		optional nouveau drm
 dev/drm/nouveau/nouveau_bo.c		optional nouveau drm
 dev/drm/nouveau/nouveau_chan.c		optional nouveau drm
 dev/drm/nouveau/nouveau_connector.c		optional nouveau drm
+#dev/drm/nouveau/nouveau_debugfs.c		optional nouveau drm
 dev/drm/nouveau/nouveau_display.c		optional nouveau drm
 dev/drm/nouveau/nouveau_dma.c		optional nouveau drm
 dev/drm/nouveau/nouveau_dp.c		optional nouveau drm
 dev/drm/nouveau/nouveau_drm.c		optional nouveau drm
-dev/drm/nouveau/nouveau_fbcon.c		optional nouveau drm
+#dev/drm/nouveau/nouveau_fbcon.c		optional nouveau drm
 dev/drm/nouveau/nouveau_fence.c		optional nouveau drm
 dev/drm/nouveau/nouveau_gem.c		optional nouveau drm
 dev/drm/nouveau/nouveau_hwmon.c		optional nouveau drm
-dev/drm/nouveau/nouveau_nv04_fbcon.c		optional nouveau drm
+#dev/drm/nouveau/nouveau_ioc32.c		optional nouveau drm
+#dev/drm/nouveau/nouveau_nv04_fbcon.c		optional nouveau drm
 dev/drm/nouveau/nouveau_nv04_fence.c		optional nouveau drm
 dev/drm/nouveau/nouveau_nv10_fence.c		optional nouveau drm
 dev/drm/nouveau/nouveau_nv17_fence.c		optional nouveau drm
 dev/drm/nouveau/nouveau_nv50_display.c		optional nouveau drm
-dev/drm/nouveau/nouveau_nv50_fbcon.c		optional nouveau drm
+#dev/drm/nouveau/nouveau_nv50_fbcon.c		optional nouveau drm
 dev/drm/nouveau/nouveau_nv50_fence.c		optional nouveau drm
 dev/drm/nouveau/nouveau_nv84_fence.c		optional nouveau drm
-dev/drm/nouveau/nouveau_nvc0_fbcon.c		optional nouveau drm
+#dev/drm/nouveau/nouveau_nvc0_fbcon.c		optional nouveau drm
 dev/drm/nouveau/nouveau_nvc0_fence.c		optional nouveau drm
 dev/drm/nouveau/nouveau_nvif.c		optional nouveau drm
+#dev/drm/nouveau/nouveau_platform.c	optional nouveau drm
 dev/drm/nouveau/nouveau_prime.c		optional nouveau drm
 dev/drm/nouveau/nouveau_sgdma.c		optional nouveau drm
-dev/drm/nouveau/nouveau_sysfs.c		optional nouveau drm
+#dev/drm/nouveau/nouveau_sysfs.c		optional nouveau drm
 dev/drm/nouveau/nouveau_ttm.c		optional nouveau drm
-dev/drm/nouveau/nouveau_usif.c		optional nouveau drm
-dev/drm/nouveau/nouveau_vga.c		optional nouveau drm
+#dev/drm/nouveau/nouveau_usif.c		optional nouveau drm
+#dev/drm/nouveau/nouveau_vga.c		optional nouveau drm
 dev/drm/nouveau/nvif/nouveau_nvif_client.c		optional nouveau drm
 dev/drm/nouveau/nvif/nouveau_nvif_device.c		optional nouveau drm
 dev/drm/nouveau/nvif/nouveau_nvif_notify.c		optional nouveau drm
diff --git a/sys/conf/kern.pre.mk b/sys/conf/kern.pre.mk
index 84b8b9484c..7f02502788 100644
--- a/sys/conf/kern.pre.mk
+++ b/sys/conf/kern.pre.mk
@@ -58,7 +58,7 @@ INCLUDES+= -I${.OBJDIR} -I"$S/${OSACPI_MI_DIR}" -I"$S/${ACPICA_DIR}/include"
 INCLUDES+= -I$S/dev/netif/ath/ath_hal -I$S/contrib/dev/ath/ath_hal
 
 # Same thing for drm includes
-INCLUDES+= -I$S/dev/drm/include
+INCLUDES+= -I$S/dev/drm/include -I$S/dev/drm/include/drm -I $S/dev/drm/nouveau -I$S/dev/drm/nouveau/core -I$S/dev/drm/nouveau/core/include
 
 COPTS=	${INCLUDES} ${IDENT} -D_KERNEL -DHAVE_KERNEL_OPTION_HEADERS -include opt_global.h
 CFLAGS=	${COPTFLAGS} ${KCFLAGS} ${CWARNFLAGS} ${DEBUG} ${COPTS}
diff --git a/sys/config/LINT64 b/sys/config/LINT64
index 4b884c283e..44226213e3 100644
--- a/sys/config/LINT64
+++ b/sys/config/LINT64
@@ -2127,6 +2127,7 @@ device		drm
 
 # For testing and debugging.
 device		"i915"
+device		nouveau
 device		radeon
 
 options 	DRM_DEBUG
diff --git a/sys/dev/drm/include/acpi/button.h b/sys/dev/drm/include/acpi/button.h
new file mode 100644
index 0000000000..df0b5c3a34
--- /dev/null
+++ b/sys/dev/drm/include/acpi/button.h
@@ -0,0 +1,57 @@
+/*	$NetBSD: button.h,v 1.2 2014/03/18 18:20:42 riastradh Exp $	*/
+
+/*-
+ * Copyright (c) 2013 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Taylor R. Campbell.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef _DRM2_COMPAT_ACPI_BUTTON_H_
+#define _DRM2_COMPAT_ACPI_BUTTON_H_
+
+struct notifier_block;
+
+/* XXX This obviously needs a real implementation...  */
+
+static inline int
+acpi_lid_notifier_register(struct notifier_block *notifier)
+{
+	return 0;
+}
+
+static inline int
+acpi_lid_notifier_unregister(struct notifier_block *notifier)
+{
+	return 0;
+}
+
+static inline int
+acpi_lid_open(void)
+{
+	return 1;
+}
+
+#endif  /* _DRM2_COMPAT_ACPI_BUTTON_H_ */
diff --git a/sys/dev/drm/include/asm/io.h b/sys/dev/drm/include/asm/io.h
index 60fc3ef047..379b26ead6 100644
--- a/sys/dev/drm/include/asm/io.h
+++ b/sys/dev/drm/include/asm/io.h
@@ -81,6 +81,13 @@ writeq(u64 value, volatile void __iomem *addr)
 		*(volatile uint32_t *)((char *)addr) = data;	\
 	} while (0)
 
+#undef writew
+static inline void
+writew(uint16_t b, void *addr)
+{
+        *(volatile uint16_t *)addr = b;
+}
+
 #include <linux/vmalloc.h>
 
 /* ioremap function family: map bus addresses into CPU space */
diff --git a/sys/dev/drm/include/drm/drmP.h b/sys/dev/drm/include/drm/drmP.h
index 0a1072c940..b9dc733e61 100644
--- a/sys/dev/drm/include/drm/drmP.h
+++ b/sys/dev/drm/include/drm/drmP.h
@@ -98,6 +98,7 @@
 #include <linux/mutex.h>
 #include <linux/slab.h>
 #include <linux/scatterlist.h>
+#include <linux/stat.h>
 #include <linux/timer.h>
 #include <asm/io.h>
 #include <linux/seq_file.h>
diff --git a/sys/dev/drm/include/drm/i2c/ch7006.h b/sys/dev/drm/include/drm/i2c/ch7006.h
new file mode 100644
index 0000000000..8390b437a1
--- /dev/null
+++ b/sys/dev/drm/include/drm/i2c/ch7006.h
@@ -0,0 +1,86 @@
+/*
+ * Copyright (C) 2009 Francisco Jerez.
+ * All Rights Reserved.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining
+ * a copy of this software and associated documentation files (the
+ * "Software"), to deal in the Software without restriction, including
+ * without limitation the rights to use, copy, modify, merge, publish,
+ * distribute, sublicense, and/or sell copies of the Software, and to
+ * permit persons to whom the Software is furnished to do so, subject to
+ * the following conditions:
+ *
+ * The above copyright notice and this permission notice (including the
+ * next paragraph) shall be included in all copies or substantial
+ * portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+ * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+ * IN NO EVENT SHALL THE COPYRIGHT OWNER(S) AND/OR ITS SUPPLIERS BE
+ * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
+ * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
+ * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+ *
+ */
+
+#ifndef __DRM_I2C_CH7006_H__
+#define __DRM_I2C_CH7006_H__
+
+/**
+ * struct ch7006_encoder_params
+ *
+ * Describes how the ch7006 is wired up with the GPU. It should be
+ * used as the @params parameter of its @set_config method.
+ *
+ * See "http://www.chrontel.com/pdf/7006.pdf" for their precise
+ * meaning.
+ */
+struct ch7006_encoder_params {
+	enum {
+		CH7006_FORMAT_RGB16 = 0,
+		CH7006_FORMAT_YCrCb24m16,
+		CH7006_FORMAT_RGB24m16,
+		CH7006_FORMAT_RGB15,
+		CH7006_FORMAT_RGB24m12C,
+		CH7006_FORMAT_RGB24m12I,
+		CH7006_FORMAT_RGB24m8,
+		CH7006_FORMAT_RGB16m8,
+		CH7006_FORMAT_RGB15m8,
+		CH7006_FORMAT_YCrCb24m8,
+	} input_format;
+
+	enum {
+		CH7006_CLOCK_SLAVE = 0,
+		CH7006_CLOCK_MASTER,
+	} clock_mode;
+
+	enum {
+		CH7006_CLOCK_EDGE_NEG = 0,
+		CH7006_CLOCK_EDGE_POS,
+	} clock_edge;
+
+	int xcm, pcm;
+
+	enum {
+		CH7006_SYNC_SLAVE = 0,
+		CH7006_SYNC_MASTER,
+	} sync_direction;
+
+	enum {
+		CH7006_SYNC_SEPARATED = 0,
+		CH7006_SYNC_EMBEDDED,
+	} sync_encoding;
+
+	enum {
+		CH7006_POUT_1_8V = 0,
+		CH7006_POUT_3_3V,
+	} pout_level;
+
+	enum {
+		CH7006_ACTIVE_HSYNC = 0,
+		CH7006_ACTIVE_DSTART,
+	} active_detect;
+};
+
+#endif
diff --git a/sys/dev/drm/include/drm/i2c/sil164.h b/sys/dev/drm/include/drm/i2c/sil164.h
new file mode 100644
index 0000000000..205e27384c
--- /dev/null
+++ b/sys/dev/drm/include/drm/i2c/sil164.h
@@ -0,0 +1,63 @@
+/*
+ * Copyright (C) 2010 Francisco Jerez.
+ * All Rights Reserved.
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining
+ * a copy of this software and associated documentation files (the
+ * "Software"), to deal in the Software without restriction, including
+ * without limitation the rights to use, copy, modify, merge, publish,
+ * distribute, sublicense, and/or sell copies of the Software, and to
+ * permit persons to whom the Software is furnished to do so, subject to
+ * the following conditions:
+ *
+ * The above copyright notice and this permission notice (including the
+ * next paragraph) shall be included in all copies or substantial
+ * portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+ * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+ * IN NO EVENT SHALL THE COPYRIGHT OWNER(S) AND/OR ITS SUPPLIERS BE
+ * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
+ * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
+ * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+ *
+ */
+
+#ifndef __DRM_I2C_SIL164_H__
+#define __DRM_I2C_SIL164_H__
+
+/**
+ * struct sil164_encoder_params
+ *
+ * Describes how the sil164 is connected to the GPU. It should be used
+ * as the @params parameter of its @set_config method.
+ *
+ * See "http://www.siliconimage.com/docs/SiI-DS-0021-E-164.pdf".
+ */
+struct sil164_encoder_params {
+	enum {
+		SIL164_INPUT_EDGE_FALLING = 0,
+		SIL164_INPUT_EDGE_RISING
+	} input_edge;
+
+	enum {
+		SIL164_INPUT_WIDTH_12BIT = 0,
+		SIL164_INPUT_WIDTH_24BIT
+	} input_width;
+
+	enum {
+		SIL164_INPUT_SINGLE_EDGE = 0,
+		SIL164_INPUT_DUAL_EDGE
+	} input_dual;
+
+	enum {
+		SIL164_PLL_FILTER_ON = 0,
+		SIL164_PLL_FILTER_OFF,
+	} pll_filter;
+
+	int input_skew; /** < Allowed range [-4, 3], use 0 for no de-skew. */
+	int duallink_skew; /** < Allowed range [-4, 3]. */
+};
+
+#endif
diff --git a/sys/dev/drm/include/linux/bitops.h b/sys/dev/drm/include/linux/bitops.h
index 634e9fe473..1eddaf9ee3 100644
--- a/sys/dev/drm/include/linux/bitops.h
+++ b/sys/dev/drm/include/linux/bitops.h
@@ -66,6 +66,13 @@ __flsl(long mask)
 	return (flsl(mask) - 1);
 }
 
+#ifdef __LP64__
+static inline int
+__ffs64(long mask)
+{
+	return (flsl(mask) - 1);
+}
+#endif
 
 #define	ffz(mask)	__ffs(~(mask))
 
diff --git a/sys/dev/drm/include/linux/compiler.h b/sys/dev/drm/include/linux/compiler.h
index 5c373b68b2..af9c875d08 100644
--- a/sys/dev/drm/include/linux/compiler.h
+++ b/sys/dev/drm/include/linux/compiler.h
@@ -39,6 +39,7 @@
 #define __force
 #define __nocast
 #define __iomem
+#define __rcu
 #define __chk_user_ptr(x)		0
 #define __chk_io_ptr(x)			0
 #define __builtin_warning(x, y...)	(1)
@@ -57,6 +58,7 @@
 #define	__attribute_const__		__attribute__((__const__))
 #undef __always_inline
 #define	__always_inline			inline
+#define noinline			__noinline
 
 #define	likely(x)			__builtin_expect(!!(x), 1)
 #define	unlikely(x)			__builtin_expect(!!(x), 0)
diff --git a/sys/dev/drm/include/linux/dma-attrs.h b/sys/dev/drm/include/linux/dma-attrs.h
new file mode 100644
index 0000000000..e28535897b
--- /dev/null
+++ b/sys/dev/drm/include/linux/dma-attrs.h
@@ -0,0 +1,50 @@
+/*-
+ * Copyright (c) 2010 Isilon Systems, Inc.
+ * Copyright (c) 2010 iX Systems, Inc.
+ * Copyright (c) 2010 Panasas, Inc.
+ * Copyright (c) 2013, 2014 Mellanox Technologies, Ltd.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice unmodified, this list of conditions, and the following
+ *    disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ * $FreeBSD: head/sys/ofed/include/linux/dma-attrs.h 289644 2015-10-20 19:08:26Z hselasky $
+ */
+#ifndef	_LINUX_DMA_ATTR_H_
+#define	_LINUX_DMA_ATTR_H_
+
+enum dma_attr { DMA_ATTR_WRITE_BARRIER, DMA_ATTR_WEAK_ORDERING, DMA_ATTR_MAX, };
+
+#define __DMA_ATTRS_LONGS BITS_TO_LONGS(DMA_ATTR_MAX)
+
+struct dma_attrs {
+	unsigned long flags;
+};
+ 
+#define DEFINE_DMA_ATTRS(x) struct dma_attrs x = { }
+
+static inline void
+init_dma_attrs(struct dma_attrs *attrs)
+{
+	attrs->flags = 0;
+}
+
+#endif	/* _LINUX_DMA_ATTR_H_ */
diff --git a/sys/dev/drm/include/linux/dma-buf.h b/sys/dev/drm/include/linux/dma-buf.h
new file mode 100644
index 0000000000..56ef9e08fb
--- /dev/null
+++ b/sys/dev/drm/include/linux/dma-buf.h
@@ -0,0 +1,35 @@
+/*	$NetBSD: dma-buf.h,v 1.2 2014/03/18 18:20:43 riastradh Exp $	*/
+
+/*-
+ * Copyright (c) 2013 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Taylor R. Campbell.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef _LINUX_DMA_BUF_H_
+#define _LINUX_DMA_BUF_H_
+
+#endif  /* _LINUX_DMA_BUF_H_ */
diff --git a/sys/dev/drm/include/linux/fb.h b/sys/dev/drm/include/linux/fb.h
index 3802ec42c9..80ed315dc6 100644
--- a/sys/dev/drm/include/linux/fb.h
+++ b/sys/dev/drm/include/linux/fb.h
@@ -38,6 +38,15 @@
 
 #define	KHZ2PICOS(a)	(1000000000UL/(a))
 
+struct fb_copyarea{
+};
+
+struct fb_fillrect {
+};
+
+struct fb_image {
+};
+
 extern int fb_get_options(const char *name, char **option);
 
 #define FBINFO_STATE_RUNNING	0
diff --git a/sys/dev/drm/include/linux/fence.h b/sys/dev/drm/include/linux/fence.h
index a60b2086c1..5360fc93da 100644
--- a/sys/dev/drm/include/linux/fence.h
+++ b/sys/dev/drm/include/linux/fence.h
@@ -27,4 +27,6 @@
 #ifndef _LINUX_FENCE_H_
 #define _LINUX_FENCE_H_
 
+struct fence { };
+
 #endif	/* _LINUX_FENCE_H_ */
diff --git a/sys/dev/drm/include/linux/gfp.h b/sys/dev/drm/include/linux/gfp.h
index f5118b4759..3cc44c3fdd 100644
--- a/sys/dev/drm/include/linux/gfp.h
+++ b/sys/dev/drm/include/linux/gfp.h
@@ -34,6 +34,7 @@
 #define GFP_ATOMIC	M_NOWAIT
 #define GFP_KERNEL	M_WAITOK
 #define GFP_TEMPORARY	M_WAITOK
+#define __GFP_NOWARN	0
 #define __GFP_ZERO	M_ZERO
 
 #define GFP_DMA32	0x10000	/* XXX: MUST NOT collide with the M_XXX definitions */
diff --git a/sys/dev/drm/include/linux/hwmon-sysfs.h b/sys/dev/drm/include/linux/hwmon-sysfs.h
new file mode 100644
index 0000000000..0fea811445
--- /dev/null
+++ b/sys/dev/drm/include/linux/hwmon-sysfs.h
@@ -0,0 +1,35 @@
+/*	$NetBSD: hwmon-sysfs.h,v 1.1 2014/07/16 20:59:58 riastradh Exp $	*/
+
+/*-
+ * Copyright (c) 2014 The NetBSD Foundation, Inc.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to The NetBSD Foundation
+ * by Taylor R. Campbell.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+ * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+ * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+ * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+ * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+ * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+ * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+ * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+ * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+ * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef	_LINUX_HWMON_SYSFS_H_
+#define	_LINUX_HWMON_SYSFS_H_
+
+#endif	/* _LINUX_HWMON_SYSFS_H_ */
